SystemOrganization addCategory: #'Pier-Caching'!

!PRInternalLink methodsFor: '*pier-caching' stamp: 'kph 10/25/2006 04:24'!
target: aStructure
	target := aStructure.
	
	self withCacheDo: [ :cache | cache internalLinkCache at: self put: target ]! !

Object subclass: #PRCache
	instanceVariableNames: 'byKey byItem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Caching'!

!PRCache commentStamp: 'kph 10/25/2006 04:05' prior: 0!
Implementation of a cache for path lookups from root.

Implemented in such a way as to provide caching for all persistency schemes. 

Cache is implemented in PRPathCache refered to by the persistency scheme by #pathCacheClass
persistency schemes can supply their own implementations.!

!PRCache class methodsFor: 'as yet unclassified' stamp: 'kph 10/25/2006 04:20'!
initialize

	#('pathCache' 'internalLinkCache') do: [ :var | 
		(PRPersistency instVarNames includes: var) 
			ifFalse: [ PRPersistency addInstVarName: var ]
	]! !

!PRCache methodsFor: 'as yet unclassified' stamp: 'kph 10/25/2006 04:32'!
at: key ifAbsentPut: aBlock

	| item |

	^byKey at: key ifAbsentPut: [ 
		byItem at: (item := aBlock value) put: key.
		item
	 ]
	 
! !

!PRCache methodsFor: 'as yet unclassified' stamp: 'kph 10/25/2006 04:34'!
at: key put: item

byItem at: item put: key.
byKey at: key put: item.! !

!PRCache methodsFor: 'as yet unclassified' stamp: 'kph 10/25/2006 04:17'!
initialize

byKey := Dictionary new.
byItem := Dictionary new.! !

!PRCache methodsFor: 'as yet unclassified' stamp: 'kph 10/25/2006 04:17'!
invalidate: cachedItem

byKey removeKey: (byItem removeKey: cachedItem).

! !

!PRCache methodsFor: 'as yet unclassified' stamp: 'kph 10/25/2006 04:32'!
lookup: aPath startingAt: aStructure fallback: aBlock

	aStructure isRoot ifFalse: [ ^aBlock value ].

	^ self at: aPath ifAbsentPut: aBlock
! !

!PRObject methodsFor: '*pier-caching' stamp: 'kph 10/24/2006 17:07'!
withCacheDo: aBlock

| context |

(context := PRCurrentContext value) ifNil: [ ^nil ].

^ aBlock value: context kernel persistency.! !

!PRPathLookup class methodsFor: '*pier-caching' stamp: 'kph 10/25/2006 03:40'!
start: aStructure path: aPathString

	^aStructure withCacheDo: [ :cache | 
		cache pathCache lookup: aPathString 
				startingAt: aStructure 
				fallback: [ self new stream: aPathString readStream; lookup: aStructure ] 
	]
			
 ! !

!PRPersistency methodsFor: '*pier-caching' stamp: 'kph 10/25/2006 03:40'!
command: aCommand critical: aBlock

	self pathCache invalidate: aCommand structure.
	self critical: aBlock

 ! !

!PRPersistency methodsFor: '*pier-caching' stamp: 'kph 10/25/2006 04:22'!
internalLinkCache

^ internalLinkCache ifNil: [ internalLinkCache := self internalLinkCacheClass new ]

 
 ! !

!PRPersistency methodsFor: '*pier-caching' stamp: 'kph 10/25/2006 04:23'!
internalLinkCacheClass

^ PRCache
 ! !

!PRPersistency methodsFor: '*pier-caching' stamp: 'kph 10/25/2006 03:39'!
pathCache

^ pathCache ifNil: [ pathCache := self pathCacheClass new ]

 ! !

!PRPersistency methodsFor: '*pier-caching' stamp: 'kph 10/25/2006 04:13'!
pathCacheClass

^ PRCache
 ! !
PRCache initialize!
